summaryrefslogtreecommitdiff
path: root/iconvdata/run-iconv-test.sh
diff options
context:
space:
mode:
authorUlrich Drepper <drepper@redhat.com>1998-04-15 00:02:59 +0000
committerUlrich Drepper <drepper@redhat.com>1998-04-15 00:02:59 +0000
commit480bc72713c841bbf55f4a33fe9f11d2c304ef1a (patch)
tree1fabef3db88905d63e17eb9c736a28aab67a162c /iconvdata/run-iconv-test.sh
parent7919ea1578f7b9e51935fb3430ae36d180c97590 (diff)
Update.
1998-04-14 23:54 Ulrich Drepper <drepper@cygnus.com> * iconvdata/Makefile: Add rules to run tests. * iconvdata/TESTS: New file. * iconvdata/run-iconv-test.sh: New file. * iconv/iconv_prog.c (main): Call process_block with OUTPUT stream, not stdout.
Diffstat (limited to 'iconvdata/run-iconv-test.sh')
-rwxr-xr-xiconvdata/run-iconv-test.sh61
1 files changed, 61 insertions, 0 deletions
diff --git a/iconvdata/run-iconv-test.sh b/iconvdata/run-iconv-test.sh
new file mode 100755
index 0000000000..2ef394d4a3
--- /dev/null
+++ b/iconvdata/run-iconv-test.sh
@@ -0,0 +1,61 @@
+#! /bin/sh -f
+# Run available iconv(1) tests.
+# Copyright (C) 1998 Free Software Foundation, Inc.
+# This file is part of the GNU C Library.
+# Contributed by Ulrich Drepper <drepper@cygnus.com>, 1998.
+#
+# The GNU C Library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Library General Public License as
+# published by the Free Software Foundation; either version 2 of the
+# License, or (at your option) any later version.
+#
+# The GNU C Library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# Library General Public License for more details.
+#
+# You should have received a copy of the GNU Library General Public
+# License along with the GNU C Library; see the file COPYING.LIB. If not,
+# write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+codir=$1
+
+# We use always the same temporary file.
+temp1=$codir/iconvdata/iconv-test.xxx
+temp2=$codir/iconvdata/iconv-test.yyy
+
+trap "rm -f $temp1 $temp2" 1 2 3 15
+
+# We must tell the iconv(1) program where the modules we want to use can
+# be found.
+GCONV_PATH=$codir/iconvdata
+export GCONV_PATH
+
+# How the start the iconv(1) program.
+ICONV="$codir/elf/ld.so --library-path $codir $codir/iconv/iconv_prog"
+
+# We read the file named TESTS. All non-empty lines not starting with
+# `#' are interpreted as commands.
+while read from to targets; do
+ # Ignore empty and comment lines.
+ if test -z "$targets" || test "$from" = '#'; then continue; fi
+
+ for t in $targets; do
+ $ICONV -f $from -t $t testdata/$from > $temp1 ||
+ { echo "*** conversion from $from to $t failed"; exit 1; }
+ $ICONV -f $t -t $to -o $temp2 $temp1 ||
+ { echo "*** conversion from $t to $to failed"; exit 1; }
+ test -s $temp1 && cmp testdata/$from $temp2 >& /dev/null ||
+ { echo "*** $from -> $t -> $to conversion failed"; exit 1; }
+
+ # All tests ok.
+ echo "$from -> $t -> $to ok"
+ #rm -f $name1 $name2
+ done
+done < TESTS
+
+exit $?
+# Local Variables:
+# mode:shell-script
+# End: